import os
import sys
import subprocess

def local(command, stdin = None):
  cmd = subprocess.Popen(command.split(' '),
                         shell=False,
                         stdout=subprocess.PIPE,
                         stderr=subprocess.PIPE)

  # Execute command and stuff out/err for returning
  cmdOut, cmdErr = cmd.communicate(stdin)
  return [ cmd.returncode, cmdOut, cmdErr ]


# Run commands through SSH to host. This accepts a third parameter which allows
# piping data over stdin to the remote SSH session. Useful for cat $STDIN etc
# Returns array with 0 == returncode 1 == stdout 2 == stderr
def SSH(host, command, stdin = None):
  ssh = subprocess.Popen(['ssh', '-A', host, command],
                         shell=False,
                         stdin=subprocess.PIPE,
                         stdout=subprocess.PIPE,
                         stderr=subprocess.PIPE)

  # Execute command and stuff out/err for returning
  sshOut, sshErr = ssh.communicate(stdin)
  return [ ssh.returncode, sshOut, sshErr ]


def SSH_pipe(host, command):
  try:
    ssh = subprocess.check_output('ssh {} {}'.format(host, command),
                                  shell=True,
                                  stderr=subprocess.STDOUT)

    return [ 0, None, None ]
  except subprocess.CalledProcessError as err:
    return [ err.returncode, None, err.output.decode('utf-8') ]
